//
//  HyxenLibProMeSettings.h
//  GeoMe
//
//  Created by Hyxen on 2011/5/4.
//  Copyright 2011年 Hyxen Tech Inc.. All rights reserved.
//

#import <Foundation/Foundation.h>

#import <CommonCrypto/CommonCryptor.h>



extern unsigned char *
CC_SHA1(const void *data, uint32_t len, unsigned char *md);


#define HXSERVICE_SETTING_KEY_PID					@"hxPid"
#define HXSERVICE_SETTING_INVALID_VALUE             -999
#define HXSERVICE_SETTING_SOUND                     @"hxSettingSound"

#define HXSERVICE_SETTING_KEY_PID_STRING            @"hxPidString"


#define HXSERVICE_SETTING_KEY_LAST_LAT              @"lastlat"
#define HXSERVICE_SETTING_KEY_LAST_LON              @"lastlon"

#define HXSERVICE_SETTING_KEY_OFFPUSH_ID                @"hxoffpush_id"
#define HXSERVICE_SETTING_KEY_OFFPUSH_FEEDBACK          @"hxoffpushFeedBack"

#define HXSERVICE_SETTING_KEY_NOLOCATIONPUSHCITY     @"hxNoLocationCity"
#define HXSERVICE_SETTING_KEY_NOLOCATIONPUSHLAT      @"hxNoLocationLat"
#define HXSERVICE_SETTING_KEY_NOLOCATIONPUSHLON      @"hxNoLocationLon"
#define HXSERVICE_SETTING_KEY_FIRSTIN                @"hxlibFirstIn"
#define HXSERVICE_PUSH_TYPE_THREE_JSON               @"hxPushTypeThreeJSON"

#define HXSERVICE_SETTING_KEY_PUSHPIDJSON   @"hxPushPidJson"

#define HXSERVICE_SETTING_KEY_SHOULDRESENDPUSHSETTING @"hxShouldResendPushSetting"
#define HXSERVICE_SETTING_KEY_PUSHSETTING1          @"hxPushSetting1"
#define HXSERVICE_SETTING_KEY_PUSHSETTING2          @"hxPushSetting2"
#define HXSERVICE_SETTING_KEY_PUSHSETTING3          @"hxPushSetting3"
#define HXSERVICE_SETTING_KEY_PUSHSETTING4          @"hxPushSetting4"
#define HXSERVICE_SETTING_KEY_PUSHSETTING5          @"hxPushSetting5"
#define HXSERVICE_SETTING_KEY_PUSHSETTING6          @"hxPushSetting6"
#define HXSERVICE_SETTING_KEY_PUSHSETTING7          @"hxPushSetting7"


#define WWSERVICE_SETTING_KEY_DEVICE_TOKEN			@"deviceToken"
#define WWSERVICE_SETTING_KEY_MCC					@"mcc"
#define WWSERVICE_SETTING_KEY_COUNTRY_CODE			@"countryCode"
#define WWSERVICE_SETTING_KEY_PHONE_NUMBER			@"phoneNumber"
#define WWSERVICE_SETTING_KEY_IDDPHONE_NUMBER		@"iddPhoneNumber"

#define WWSERVICE_SETTING_KEY_LOGIN_KEY				@"key"
#define WWSERVICE_SETTING_KEY_MID					@"mid"
#define WWSERVICE_SETTING_KEY_STATUS				@"status"
#define WWSERVICE_SETTING_KEY_STATUS_MESSAGE		@"statusMessage"

#define WWSERVICE_SETTING_KEY_RESTORE				@"restore"
#define WWSERVICE_SETTING_KEY_RESTORE_VID			@"restoreVid"
#define WWSERVICE_SETTING_KEY_RESTORE_CALLTO		@"callTo"
#define WWSERVICE_SETTING_KEY_RESTORE_PHONE			@"restorePhone"
#define WWSERVICE_SETTING_KEY_RESTORE_IDDPHONE		@"restoreIddPhone"
#define WWSERVICE_SETTING_KEY_RESTORE_MCC			@"restoreMcc"
#define WWSERVICE_SETTING_KEY_RESTORE_COUNTRY_CODE	@"restoreCountryCode"


#define WWSERVICE_SETTING_INVALID_DATA			nil
#define HxShareFaceBookKey			@"191864424230760"
@interface HyxenLibProMeSettings : NSObject {
	
}



@property (nonatomic) int mcc;
@property (nonatomic, retain) NSString *countryCode;

@property (nonatomic, retain) NSString *iddPhoneNumber;
@property (nonatomic) long long pid;
@property (nonatomic, retain) NSString *pidString;
@property (nonatomic, retain) NSString *pidJson;
@property (nonatomic, retain) NSString *key;
@property (nonatomic) long long mid;

@property (nonatomic) long long offPushId;
@property (nonatomic, retain)   NSString *offPushFeedback;

@property (nonatomic, retain) NSString *pushSound; 
@property (nonatomic) BOOL shouldResendPushSetting;
@property (nonatomic) BOOL pushSetting1;
@property (nonatomic) BOOL pushSetting2;
@property (nonatomic) BOOL pushSetting3;
@property (nonatomic) BOOL pushSetting4;
@property (nonatomic) BOOL pushSetting5;
@property (nonatomic) BOOL pushSetting6;
@property (nonatomic) BOOL pushSetting7;
@property (nonatomic) BOOL firstIn;

@property (nonatomic, retain) NSString *lastLat;
@property (nonatomic, retain) NSString *lastLon;
@property (nonatomic, retain) NSString *statusMessage;
@property (nonatomic, readonly) BOOL registed;



@property (nonatomic) BOOL restore;
@property (nonatomic, readonly) BOOL backgroundSupport;
@property (nonatomic) long long restoreVid;
@property (nonatomic, retain) NSString *restoreCallTo;
@property (nonatomic, retain) NSString *restorePhone;
@property (nonatomic, retain) NSString *restoreIddPhone;
@property (nonatomic) int restoreMcc;
@property (nonatomic, retain) NSString *restoreCountryCode;

@property (nonatomic, retain) NSString *noLocationPushCity;
@property (nonatomic, retain) NSString *noLocationPushLat;
@property (nonatomic, retain) NSString *noLocationPushLon;
@property (nonatomic, retain) NSString *pushTypeThreeJSON;
+ (HyxenLibProMeSettings *)sharedSetting;
+ (NSString *)documentPath;
- (void)synchronize;

@end
