//
//  HyxenProMeADInterstitial.h
//  HyxenAdLocus_SDKSample
//
//  Created by Hyxen on 13/2/1.
//
//

#import <Foundation/Foundation.h>
#import "HyxenProMeADInterstitialDelegate.h"
#import "HyXenProMeADRequest.h"

typedef enum {
    AdLocusInterstitialAnimationTypeNone           = 0,
    AdLocusInterstitialAnimationTypeFlipFromLeft   = 1,
    AdLocusInterstitialAnimationTypeFlipFromRight  = 2,
    AdLocusInterstitialAnimationTypeCurlUp         = 3,
    AdLocusInterstitialAnimationTypeCurlDown       = 4,
    AdLocusInterstitialAnimationTypeSlideFromLeft  = 5,
    AdLocusInterstitialAnimationTypeSlideFromRight = 6,
    AdLocusInterstitialAnimationTypeFadeIn         = 7,
    AdLocusInterstitialAnimationTypeRandom         = 8,
} AdLocusInterstitialAnimationType;


@interface HyxenProMeADInterstitial : UIView<HyxenProMeADInterstitialDelegate,UIWebViewDelegate>
{
    id<HyxenProMeADInterstitialDelegate> delegate;
    NSTimer *refreshTimer;
    
    BOOL ignoreAutoRefreshTimer;
    BOOL ignoreNewAdRequests;
    BOOL appInactive;
    BOOL showingModalView;
    BOOL auth;
    
    NSMutableDictionary *hxUserInfo;
    //    HyXenProMeADCustomBannerView *customBanner;
    CLLocation *hxLocationInfo;
    NSString *hxJson;
    NSString *hxAppKey;
    NSString *hxAdId;
    NSString *hxAdType;
    NSString *hxAdBody;
    UIImage *hxAdLeftIcon;
    UIImage *hxAdImg;
    int hxAdLinkType;
    NSString *hxAdLink;
    NSString *hxSid;
    int hxSec;
    
    
    BOOL hxBannerShouldBePause;
    BOOL hxFirstCome;
    UIImageView *hxLeftIconImageView;
    UIImageView *hxRightIconImageView;
    UIImageView *hxBannerImageView;
    UIImageView *hxBackgroundImageView;
    UIImageView *hxLogoImageView;
    
    UILabel *hxButtonLabel;
    UIImageView *hxButtonFrame;
    
    UILabel *hxBodyLabel;
    
    UIButton *hxButton;
    NSString *hxBannerType;
    NSTimer *bannerTimer;
    NSTimer *impressionTimer;
    
    //HyxenAdWebBrowserController *hxWebBrowserController;
    
    AdLocusInterstitialAnimationType interstitialAnimationType;
    
    UIWebView *hxBannerWebView;
    NSString *hxTagId;
    UIButton *hxCloseButton;
}

#pragma mark Making an Ad Request

// Makes an interstitial ad request.  Additional targeting options can be
// supplied with a request object.  Only one interstitial request is allowed at
// a time.
//
// This is best to do several seconds before the interstitial is needed to
// preload its content.  Then when transitioning between view controllers show
// the interstital with presentFromViewController.
- (void)loadRequest:(HyXenProMeADRequest *)request;

#pragma mark Request at Application Launch

// The |window| will be shown with the |image| displayed until either the
// |request| interstitial is shown or a timeout occurs.  The delegate will
// receive an interstitialDidDismissScreen: callback to indicate that your app
// should continue when the interstitial has finished.
- (void)loadAndDisplayRequest:(HyXenProMeADRequest *)request
                  usingWindow:(UIWindow *)window
                 initialImage:(UIImage *)image;

#pragma mark Post-Request
@property (nonatomic, assign) NSObject<HyxenProMeADInterstitialDelegate> *delegate;
// Returns YES if the interstitial is ready to be displayed.  The delegate's
// interstitialAdDidReceiveAd: will be called when this switches from NO to YES.
@property (nonatomic, readonly) BOOL isReady;

// Returns YES if the interstitial object has already shown an interstitial.
// Note that an interstitial object can only be used once even with different
// requests.
@property (nonatomic, readonly) BOOL hasBeenUsed;

// Presents the interstitial ad which takes over the entire screen until the
// user dismisses it.  This has no effect unless isReady returns YES and/or the
// delegate's interstitialDidReceiveAd: has been received.
//
// Set rootViewController to the current view controller at the time this method
// is called.  If your application does not use view controllers pass in nil and
// your views will be removed from the window to show the interstitial and
// restored when done.  After the interstitial has been removed, the delegate's
// interstitialDidDismissScreen: will be called.
- (void)presentFromRootViewController:(UIViewController *)rootViewController;



- (void)setInterstitialAnimationType:(AdLocusInterstitialAnimationType)type;


- (HyxenProMeADInterstitial * )requestAdViewWithDelegate:(id<HyxenProMeADInterstitialDelegate>)d ;


// Required reference to the current root view controller.  For example the root
// view controller in tab-based application would be the UITabViewController.
@property (nonatomic, assign) UIViewController *rootViewController;



@property (nonatomic,retain) NSTimer *refreshTimer;

@property (nonatomic, retain) NSString *hxJson;
@property (nonatomic, retain) NSString *hxAdId;
@property (nonatomic, retain) NSString *hxAdType;
@property (nonatomic, retain) NSString *hxAdBody;
@property (nonatomic, retain) UIImage *hxAdLeftIcon;
@property (nonatomic, retain) UIImage *hxAdImg;
@property (nonatomic) int hxAdLinkType;
@property (nonatomic, retain) NSString *hxAdLink;
@property (nonatomic, retain) NSString *hxSid;
@property (nonatomic) int hxSec;
@property (nonatomic, retain) CLLocation *hxLocationInfo;
@property (nonatomic, retain) NSMutableDictionary *hxUserInfo;


#pragma mark Ad Request



@property (nonatomic, readonly) BOOL hasAutoRefreshed;
@end
